/***********************************************************************************************
Copyright (C) 1996, 1997, 2012 Paolo Zuliani.  All rights reserved.
By using this software the USER indicates that he or she has read, understood 
and will comply with the following:

1. The USER is hereby granted non-exclusive permission to use, copy and/or
modify this software for internal, non-commercial, research purposes only. Any
distribution, including commercial sale or license, of this software, copies of
the software, its associated documentation and/or modifications of either is
strictly prohibited without the prior consent of the authors. Title to copyright
to this software and its associated documentation shall at all times remain with
the authors. Appropriated copyright notice shall be placed on all software
copies, and a complete copy of this notice shall be included in all copies of
the associated documentation. No right is granted to use in advertising,
publicity or otherwise any trademark, service mark, or the name of the authors.

2. This software and any associated documentation is provided "as is".

THE AUTHORS MAKE NO REPRESENTATIONS OR WARRANTIES, EXPRESSED OR IMPLIED,
INCLUDING THOSE OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, OR THAT
USE OF THE SOFTWARE, MODIFICATIONS, OR ASSOCIATED DOCUMENTATION WILL NOT
INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER INTELLECTUAL PROPERTY
RIGHTS OF A THIRD PARTY.

The authors shall not be liable under any circumstances for any direct,
indirect, special, incidental, or consequential damages with respect to any
claim by USER or any third party on account of or arising from the use, or
inability to use, this software or its associated documentation, even if the
authors have been advised of the possibility of those damages.
***********************************************************************************************/


/*
 * bitinfo.c
 *
 * Scrive su stdout le lunghezze in bit di alcuni tipi base:
 *	long, int, char, short, float, double.
 */

#include <stdio.h>

void main(int argc, char *argv[])
{
  unsigned long aLong = ~0;				/* pone tutti i bit a 1 */
  int byteSize;							/* lunghezza di un byte */
  int b;


  /* Calcola la lunghezza di un long */
  for (b = 0; aLong != 0; aLong >>= 1)
	if (aLong & (unsigned)1) b++;

  /* Calcola la lunghezza di un byte */
  byteSize = b / sizeof (aLong);
  
  printf ("Lunghezze in bit di alcuni tipi base del C su questa macchina.\n");
  printf ("int   : %d\n", sizeof (int) * byteSize);
  printf ("short : %d\n", sizeof (short) * byteSize);
  printf ("long  : %d\n", b);
  printf ("char  : %d\n", sizeof (char) * byteSize);
  printf ("float : %d\n", sizeof (float) * byteSize);
  printf ("double: %d\n", sizeof (double) * byteSize);
  printf ("byte di sizeof(): %d bit\n", byteSize);
}
